#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hellsing.h"

int tindex = -1;
struct targets **target;

char key[MAX_KEY_SIZE];
char value[MAX_VALUE_SIZE];

int build_targets(void) {
	FILE *fd;
	char buf[1024];
	
	if(!(fd = fopen(configfile, "r"))) {
		return(1);
	}
	
	if(!(target = malloc(sizeof(struct targets) * MAX_TARGETS))) {
		fclose(fd);
		return(1);
	}
	
	while(fgets(buf, sizeof(buf), fd) != NULL) {
		chomp(buf);
		getKey(buf);
		if(!strcasecmp(key, "target")) {
			getValue(buf);
			tindex++;
			target[tindex] = malloc(sizeof(struct targets));
			target[tindex]->name = malloc(strlen(value)+1);
			target[tindex]->option = NULL;
			target[tindex]->cookie = NULL;
			target[tindex]->ssl = 0;
			strcpy(target[tindex]->name, value);
		}
		if(!strcasecmp(key, "description")) {
			getValue(buf);
			searchAndReplaceNewLines(value);
			target[tindex]->description = malloc(strlen(value)+1);
			strcpy(target[tindex]->description, value);
		}
		if(!strcasecmp(key, "request_method")) {
			getValue(buf);
			if(!strcasecmp(value, "get")) {
				target[tindex]->request_method = GET;
			} else if(!strcasecmp(value, "post")) {
				target[tindex]->request_method = POST;
			}
		}
		if(!strcasecmp(key, "request_uri")) {
			getValue(buf);
			target[tindex]->request_uri = malloc(strlen(value)+1);
			strcpy(target[tindex]->request_uri, value);
		}
		if(!strcasecmp(key, "option")) {
			getValue(buf);
			if(target[tindex]->option == NULL) {
				target[tindex]->option = malloc(sizeof(struct options));
				target[tindex]->option->prev = NULL;
				target[tindex]->option->next = NULL;
				target[tindex]->option->key = malloc(strlen(value)+1);
				strcpy(target[tindex]->option->key, value);
			} else {
				{
					struct options *op;
					op = target[tindex]->option;
					target[tindex]->option = malloc(sizeof(struct options));
					target[tindex]->option->prev = op;
					op->next = target[tindex]->option;
					target[tindex]->option->next = NULL;
					target[tindex]->option->key = malloc(strlen(value)+1);
					strcpy(target[tindex]->option->key, value);
				}
			}
				
		}
		if(!strcasecmp(key, "option_description")) {
			getValue(buf);
			target[tindex]->option->value = malloc(strlen(value)+1);
			strcpy(target[tindex]->option->value, value);
		}
		if(!strcasecmp(key, "cookie_name")) {
			getValue(buf);
			if(target[tindex]->cookie == NULL) {
				target[tindex]->cookie = malloc(sizeof(struct cookies));
				target[tindex]->cookie->prev = NULL;
				target[tindex]->cookie->next = NULL;
				target[tindex]->cookie->name = malloc(strlen(value)+1);
				strcpy(target[tindex]->cookie->name, value);
			} else {
				{
					struct cookies *cook;
					cook = target[tindex]->cookie;
					target[tindex]->cookie = malloc(sizeof(struct cookies));
					target[tindex]->cookie->prev = cook;
					cook->next = target[tindex]->cookie;
					target[tindex]->cookie->next = NULL;
					target[tindex]->cookie->name = malloc(strlen(value)+1);
					strcpy(target[tindex]->cookie->name, value);
				}
			}
		}
		if(!strcasecmp(key, "cookie_value")) {
			getValue(buf);
			target[tindex]->cookie->value = malloc(strlen(value)+1);
			strcpy(target[tindex]->cookie->value, value);
		}
		if(!strcasecmp(key, "use_ssl")) {
			getValue(buf);
			if((!strcasecmp(value, "yes")) || (!strcasecmp(value, "true"))) {
				target[tindex]->ssl = 1;
			}
		}
	}
	
	return(tindex);
}


char *getKey(char *line) {
	char *sp, *ep;
	char *p;
	int i = 0;
	
	sp = line;
	sp = skipWhiteSpace(sp);
	ep = sp;
	while((*ep != ' ') && (*ep != '\t') && (*ep != '\0')) {
		ep++;
	}
	p = key;
	while((sp != ep) && (i < MAX_KEY_SIZE)) {
		*p++ = *sp++;
		i++;
	}
	*p = 0;
	return(key);
}


char *getValue(char *line) {
	char *sp;
	
	memset(value, 0, MAX_VALUE_SIZE);
	sp = strchr(line, '=');
	sp++;
	sp = skipWhiteSpace(sp);
	strncpy(value, sp, sizeof(value)-1);
	strcat(value, "\x00");
	return(sp);
}


char *skipWhiteSpace(char *line) {
	while((*line == ' ') || (*line == '\t')) {
		line++;
	}
	return(line);
}


char *chomp(char *line) {
	char *ep;
	ep = line + strlen(line) - 1;
	while((*ep == '\n') || (*ep == '\r')) {
		--ep;
	}
	*++ep = 0;
	return(line);
}

char *searchAndReplaceNewLines(char *line) {
	char buf[MAX_VALUE_SIZE];
	char *p = line;
	char *s = p;
	int i = 0;
	
	memset(buf, 0, sizeof(buf));
	while((p = strstr(p, "\\n"))) {
		*p++ = '\n';
		*p++ = '\0';
		i += strlen(s);
		if(i > MAX_VALUE_SIZE) {
			return(NULL);
		}
		strcat(buf, s);
		s = p;
	}
	strcat(buf, s);
	memset(value, 0, MAX_VALUE_SIZE);
	strcpy(value, buf);
	return(value);
}

void rewindList(void) {
	int i = 0;
	
	for(i=0; i<tindex; i++) {
		while(target[i]->option->prev) {
			target[i]->option = target[i]->option->prev;
		}
	}
}

void rewindCookieList(void) {
	int i = 0;
	
	for(i=0; i<tindex; i++) {
		if(target[i]->cookie) {
			while(target[i]->cookie->prev) {
				target[i]->cookie = target[i]->cookie->prev;
			}
		}
	}
}
