#ifndef MAIN_H_
#define MAIN_H_

#define DEFAULT_PORT 80
#define DEFAULT_SSL_PORT 443
#define MAX_TARGETS 8192
#define MAX_KEY_SIZE 1024
#define MAX_VALUE_SIZE 2048
#define MAX_ARGUMENTS 16
#define MAX_BUF_LEN 8192
#define GET 0
#define POST 1

// stuff for making the query look as though its coming from a real browser
#define USER_AGENT "Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.0.4) Gecko/20060508 Firefox/1.5.0.4"
#define ACCEPT "text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5"
#define ACCEPT_LANGUAGE "en-us,en;q=0.5"
#define ACCEPT_ENCODING "gzip,deflate"
#define ACCEPT_CHARSET "ISO-8859-1,utf-8;q=0.7,*;q=0.7"
#define KEEPALIVE "300"
#define CONNECTION "keep-alive"

extern int tindex;
extern char *configfile;
extern struct targets **target;

struct targets {
	char *name;
	char *description;
	int request_method;
	int ssl;
	char *request_uri;
	struct options *option;
	struct cookies *cookie;
};

struct options {
	char *key;
	char *value;
	struct options *prev;
	struct options *next;
};

struct cookies {
	char *name;
	char *value;
	struct cookies *prev;
	struct cookies *next;
};

int build_targets(void);
char *getTargetName(char *);
char *getKey(char *);
char *getValue(char *);
char *skipWhiteSpace(char *);
char *chomp(char *);
char *searchAndReplaceNewLines(char *);
int getOptionIndex(void);
void rewindList(void);
void rewindCookieList(void);
char *buildAttackBuffer(int, char *, char *);
char *processFormatString(char, int, char *, char *, char *);
char *getReplaceValue(char, char *, char *);
int createSocket(int, char *, int);
void sendAttack(int, char *, char *, char *);
void readResponse(char *, int);
char *encodeChr(char *, char *);
void usage(void);

#endif /*MAIN_H_*/
